//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
// HistoryListCtrl. emulEspaa Mod: Added by MoNKi
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once

#include "emule.h"
#include "types.h"
#include "MuleListCtrl.h"
#include "KnownFile.h"

// CHistoryListCtrl

class CHistoryListCtrl : public CMuleListCtrl
{
	DECLARE_DYNAMIC(CHistoryListCtrl)

public:
	CHistoryListCtrl();
	virtual ~CHistoryListCtrl();
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

	void	Init(void);
	void	AddFile(CKnownFile* toadd);
	void	Localize();
	//void	CreateMenues(); // [TPT] - New Menu Styles
	void	Reload(void);
	void	ShowComments(int index);
	void	RemoveFile(CKnownFile* toremove);	
	void	ClearHistory();	

protected:
	DECLARE_MESSAGE_MAP()

	afx_msg	void OnColumnClick( NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnNMDblclk(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnMeasureItem(int nIDCtl, LPMEASUREITEMSTRUCT lpMeasureItemStruct);// [TPT] - New Menu Style
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	static int CALLBACK SortProc(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort);

private:
	//CTitleMenu	m_HistoryMenu; // [TPT] - New Menu Style
	//CMenu		m_HistoryOpsMenu; // [TPT] - New Menu Style
	void		OpenFile(CKnownFile* file);
};


